
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ConsentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const consents = await db.consents.create(
            {
                id: data.id || undefined,
        
        consent_type: data.consent_type
        ||
        null
            ,
            
        version: data.version
        ||
        null
            ,
            
        granted: data.granted
        ||
        false
        
            ,
            
        granted_at: data.granted_at
        ||
        null
            ,
            
        context_json: data.context_json
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await consents.setUser( data.user || null, {
            transaction,
        });
        
        await consents.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return consents;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const consentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                consent_type: item.consent_type
            ||
            null
            ,
            
                version: item.version
            ||
            null
            ,
            
                granted: item.granted
            ||
            false
        
            ,
            
                granted_at: item.granted_at
            ||
            null
            ,
            
                context_json: item.context_json
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const consents = await db.consents.bulkCreate(consentsData, { transaction });

        // For each item created, replace relation files
        

        return consents;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const consents = await db.consents.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.consent_type !== undefined) updatePayload.consent_type = data.consent_type;
        
        
        if (data.version !== undefined) updatePayload.version = data.version;
        
        
        if (data.granted !== undefined) updatePayload.granted = data.granted;
        
        
        if (data.granted_at !== undefined) updatePayload.granted_at = data.granted_at;
        
        
        if (data.context_json !== undefined) updatePayload.context_json = data.context_json;
        
        
        updatePayload.updatedById = currentUser.id;

        await consents.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await consents.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await consents.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return consents;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const consents = await db.consents.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of consents) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of consents) {
                await record.destroy({transaction});
            }
        });


        return consents;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const consents = await db.consents.findByPk(id, options);

        await consents.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await consents.destroy({
            transaction
        });

        return consents;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const consents = await db.consents.findOne(
            { where },
            { transaction },
        );

        if (!consents) {
            return consents;
        }

        const output = consents.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await consents.getUser({
            transaction
        });
        
        
        output.organizations = await consents.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.version) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'consents',
                        'version',
                        filter.version,
                    ),
                };
            }
            
            if (filter.context_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'consents',
                        'context_json',
                        filter.context_json,
                    ),
                };
            }
            

            
            

            
            if (filter.granted_atRange) {
                const [start, end] = filter.granted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    granted_at: {
                    ...where.granted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    granted_at: {
                    ...where.granted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.consent_type) {
                where = {
                    ...where,
                consent_type: filter.consent_type,
            };
            }
            
            if (filter.granted) {
                where = {
                    ...where,
                granted: filter.granted,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.consents.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'consents',
                        'consent_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.consents.findAll({
            attributes: [ 'id', 'consent_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['consent_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.consent_type,
        }));
    }

    
};

